/*
 * Created on Mar 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package gov.nasa.du.schemavalidator;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;

import org.apache.xerces.xni.parser.XMLParseException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * @author mrabi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SchemaValidator extends DefaultHandler {
	//
	// Constants
	//

	// feature ids

	/** Namespaces feature id (http://xml.org/sax/features/namespaces). */
	protected static final String NAMESPACES_FEATURE_ID =
		"http://xml.org/sax/features/namespaces";

	/** Namespace prefixes feature id (http://xml.org/sax/features/namespace-prefixes). */
	protected static final String NAMESPACE_PREFIXES_FEATURE_ID =
		"http://xml.org/sax/features/namespace-prefixes";

	/** Validation feature id (http://xml.org/sax/features/validation). */
	protected static final String VALIDATION_FEATURE_ID =
		"http://xml.org/sax/features/validation";

	/** Schema validation feature id (http://apache.org/xml/features/validation/schema). */
	protected static final String SCHEMA_VALIDATION_FEATURE_ID =
		"http://apache.org/xml/features/validation/schema";

	/** Schema full checking feature id (http://apache.org/xml/features/validation/schema-full-checking). */
	protected static final String SCHEMA_FULL_CHECKING_FEATURE_ID =
		"http://apache.org/xml/features/validation/schema-full-checking";

	/** Dynamic validation feature id (http://apache.org/xml/features/validation/dynamic). */
	protected static final String DYNAMIC_VALIDATION_FEATURE_ID =
		"http://apache.org/xml/features/validation/dynamic";

	// default settings

	/** Default parser name. */
	protected static final String DEFAULT_PARSER_NAME =
		"org.apache.xerces.parsers.SAXParser";

	/** Default repetition (1). */
	protected static final int DEFAULT_REPETITION = 1;

	/** Default namespaces support (true). */
	protected static final boolean DEFAULT_NAMESPACES = true;

	/** Default namespace prefixes (ture). */
	protected static final boolean DEFAULT_NAMESPACE_PREFIXES = true;

	/** Default validation support (ture). */
	protected static final boolean DEFAULT_VALIDATION = true;

	/** Default Schema validation support (true). */
	protected static final boolean DEFAULT_SCHEMA_VALIDATION = true;

	/** Default Schema full checking support (true). */
	protected static final boolean DEFAULT_SCHEMA_FULL_CHECKING = false;

	/** Default dynamic validation support (false). */
	protected static final boolean DEFAULT_DYNAMIC_VALIDATION = false;

	/** Default memory usage report (true). */
	protected static final boolean DEFAULT_MEMORY_USAGE = true;

	/** Default "tagginess" report (true). */
	protected static final boolean DEFAULT_TAGGINESS = true;

	//
	// Protected methods
	//

	/** Prints the error message. */
	protected void printError(String type, XMLParseException ex) {

		System.err.print("[");
		System.err.print(type);
		System.err.print("] ");
		String systemId = ex.getExpandedSystemId();
		if (systemId != null) {
			int index = systemId.lastIndexOf('/');
			if (index != -1)
				systemId = systemId.substring(index + 1);
			System.err.print(systemId);
		}
		System.err.print(':');
		System.err.print(ex.getLineNumber());
		System.err.print(':');
		System.err.print(ex.getColumnNumber());
		System.err.print(": ");
		System.err.print(ex.getMessage());
		System.err.println();
		System.err.flush();

	} // printError(String,XMLParseException)

	/** Prints the error message. */
	protected void printSAXError(String type, SAXParseException ex) {

		System.err.print("[");
		System.err.print(type);
		System.err.print("] ");
		String systemId = ex.getSystemId();
		if (systemId != null) {
			int index = systemId.lastIndexOf('/');
			if (index != -1)
				systemId = systemId.substring(index + 1);
			System.err.print(systemId);
		}
		System.err.print("[line:");
		System.err.print(ex.getLineNumber());
		System.err.print("][column:");
		System.err.print(ex.getColumnNumber());
		System.err.print("]: ");
		System.err.print(ex.getMessage());
		System.err.println();
		System.err.flush();

	} // printError(String,XMLParseException)

	protected String getSAXError(String type, SAXParseException ex) {
		String result = "";
		//result = "[" + type +"] ";
		String systemId = ex.getSystemId();
		if (systemId != null) {
			int index = systemId.lastIndexOf('/');
			if (index != -1)
				systemId = systemId.substring(index + 1);
			result += systemId;
		}
		result += "[line:"
			+ ex.getLineNumber()
			+ "][column:"
			+ ex.getColumnNumber();
		result += "]: " + ex.getMessage() + '\n';
		return result;

	}

	public static void main(String[] argv) {
		String logFileName = null;
		String logFilter = null;
		BufferedWriter out = null;
		// is there anything to do?
		if (argv.length == 0) {
			printUsage();
			System.exit(1);
		}
		SchemaValidator handler = new SchemaValidator();
		// variables

		XMLReader parser = null;
		int repetition = DEFAULT_REPETITION;
		boolean namespaces = DEFAULT_NAMESPACES;
		boolean namespacePrefixes = DEFAULT_NAMESPACE_PREFIXES;
		boolean validation = DEFAULT_VALIDATION;
		boolean schemaValidation = DEFAULT_SCHEMA_VALIDATION;
		boolean schemaFullChecking = DEFAULT_SCHEMA_FULL_CHECKING;
		boolean dynamicValidation = DEFAULT_DYNAMIC_VALIDATION;
		boolean memoryUsage = DEFAULT_MEMORY_USAGE;
		boolean tagginess = DEFAULT_TAGGINESS;

		// process arguments
		for (int i = 0; i < argv.length; i++) {
			String arg = argv[i];
			if (arg.startsWith("-")) {
				String option = arg.substring(1);

				if (option.equals("o")) {
					if (++i == argv.length) {
						System.err.println(
							"error: Missing argument to -o option. Log filename must be supplied.");
						System.exit(-1);
					}
					logFileName = argv[i];
					System.out.println(
						"Saving output to log file: " + logFileName);
					try {
						out = new BufferedWriter(new FileWriter(logFileName));
					} catch (Exception e) {
						e.printStackTrace();
					}
					continue;
				}
				if (option.equals("f")) {
					if (++i == argv.length) {
						System.err.println(
							"Error: Missing argument to -f option. Filter is one of ['w','e','f'] for warning, errors, or fatal errors");
						System.exit(-1);
					}
					if (!(logFilter.equals("w")
						|| logFilter.equals("e")
						|| logFilter.equals("f"))) {
						System.err.println(
							"Warning: Wrong argument to -f option. Filter is one of ['w','e','f'] for warning, errors, or fatal errors");
						System.err.println("All errors will be logged...");
						continue;
					}
					System.out.print("logFilter:" + logFilter);
					continue;
				}
				if (option.equals("h")) {
					printUsage();
					continue;
				}
				System.err.println("Error: unknown option (" + option + ").");
				continue;
			} // use default parser?
			if (parser == null) { // create parser
				try {

					parser =
						XMLReaderFactory.createXMLReader(DEFAULT_PARSER_NAME);
				} catch (Exception e) {
					System.err.println(
						"error: Unable to instantiate parser ("
							+ DEFAULT_PARSER_NAME
							+ ")");
					continue;
				}
			} // parse file
			parser.setContentHandler(handler);
			parser.setErrorHandler(handler);
			try {

				SchemaValidatorController svc =
					new SchemaValidatorController(handler, arg, false);
				svc.validateFile();
				if (logFileName != null) {

					try {

						if (logFilter != null) {
							if (logFilter.equals("w")) {
								Iterator itr = svc.warnExceptions.iterator();
								while (itr.hasNext()) {
									out.write(
										"[warning] "
											+ itr.next().toString()
											+ "\n");
								}
							} else if (logFilter.equals("e")) {
								Iterator itr = svc.errorExceptions.iterator();
								while (itr.hasNext()) {
									out.write(
										"[error] "
											+ itr.next().toString()
											+ "\n");
								}
							} else if (logFilter.equals("f")) {
								Iterator itr =
									svc.fatalErrorExceptions.iterator();
								while (itr.hasNext()) {
									out.write(
										"[fatal error] "
											+ itr.next().toString()
											+ "\n");
								}
							} else {
								Iterator itr =
									itr = svc.warnExceptions.iterator();
								while (itr.hasNext()) {
									out.write(
										"[warning] "
											+ itr.next().toString()
											+ "\n");
								}
								itr = svc.errorExceptions.iterator();
								while (itr.hasNext()) {
									out.write(
										"[error] "
											+ itr.next().toString()
											+ "\n");
								}
								itr = svc.fatalErrorExceptions.iterator();
								while (itr.hasNext()) {
									out.write(
										"[fatal error] "
											+ itr.next().toString()
											+ "\n");
								}
							}
						} else {
							Iterator itr = itr = svc.warnExceptions.iterator();
							while (itr.hasNext()) {
								out.write(
									"[warning] "
										+ itr.next().toString()
										+ "\n");
							}
							itr = svc.errorExceptions.iterator();
							while (itr.hasNext()) {
								out.write(
									"[error] " + itr.next().toString() + "\n");
							}
							itr = svc.fatalErrorExceptions.iterator();
							while (itr.hasNext()) {
								out.write(
									"[fatal error] "
										+ itr.next().toString()
										+ "\n");
							}
						}

					} catch (IOException e) {
						e.printStackTrace();
					}

				} else {
					System.out.print(
						"Errors:" + svc.errorExceptions.toString());
				}

			} catch (Exception e) {
				System.err.println(
					"error: Parse error occurred - " + e.getMessage());
				Exception se = e;
				if (e instanceof SAXException) {
					se = ((SAXException) e).getException();
				}
				if (se != null)
					se.printStackTrace(System.err);
				else
					e.printStackTrace(System.err);
			}

		}
		if (out != null) {

			System.out.println("Finished writing logs to file: " + logFileName);
			try {
				out.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	public SchemaValidator() {
		super();
	} //
	// Private static methods
	//
	/** Prints the usage. */
	private static void printUsage() {

		System.err.println(
			"usage: java -cp \"xercersImpl.jar;xml-api.jar;sv.jar\" gov.nasa.du.schemavalidator.SchemaValidator (options) file1 [,file2,file3,...]");
		System.err.println();
		System.err.println("options:");
		System.err.println("  -o logfilename     log errors to this file.");
		System.err.println("  -h          This help screen.");
		System.err.println(
			"  -f          Filter error logs; one of these ['w','e','f'] 'e' Errors, 'w' Warnings, 'f' Fatal Errors only.");
		System.err.println();
	}
	//  Warning Event Handler
	public void warning(SAXParseException e) throws SAXException {
		//printSAXError("Warning",e);
		UIHelper.logWarning(
			getSAXError("Warning", e),
			getSAXError("Warning", e));
		SchemaValidatorController.warnExceptions.add(getSAXError("Warning", e));
	} //  Error Event Handler
	public void error(SAXParseException e) throws SAXException {
		//printSAXError("Error",e);
		UIHelper.logError(getSAXError("Error", e), getSAXError("Error", e));
		SchemaValidatorController.errorExceptions.add(getSAXError("Error", e));
	} //  Fatal Error Event Handler
	public void fatalError(SAXParseException e) throws SAXException {
		//printSAXError("Fatal Error",e);
		UIHelper.logFatalError(
			getSAXError("Fatal Error", e),
			getSAXError("Fatal Error", e));
		SchemaValidatorController.fatalErrorExceptions.add(
			getSAXError("Fatal Error", e));
	}

	public void setupParserFeatures(XMLReader parser) {
		boolean namespaces = DEFAULT_NAMESPACES;
		boolean namespacePrefixes = DEFAULT_NAMESPACE_PREFIXES;
		boolean validation = DEFAULT_VALIDATION;
		boolean schemaValidation = DEFAULT_SCHEMA_VALIDATION;
		boolean schemaFullChecking = DEFAULT_SCHEMA_FULL_CHECKING;
		boolean dynamicValidation = DEFAULT_DYNAMIC_VALIDATION;
		//		set parser features
		try {
			parser.setFeature(NAMESPACES_FEATURE_ID, namespaces);
		} catch (SAXException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ NAMESPACES_FEATURE_ID
					+ ")");
		}
		try {
			parser.setFeature(NAMESPACE_PREFIXES_FEATURE_ID, namespacePrefixes);
		} catch (SAXException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ NAMESPACE_PREFIXES_FEATURE_ID
					+ ")");
		}
		try {
			parser.setFeature(VALIDATION_FEATURE_ID, validation);
		} catch (SAXException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ VALIDATION_FEATURE_ID
					+ ")");
		}
		try {
			parser.setFeature(SCHEMA_VALIDATION_FEATURE_ID, schemaValidation);
		} catch (SAXNotRecognizedException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ SCHEMA_VALIDATION_FEATURE_ID
					+ ")");
		} catch (SAXNotSupportedException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ SCHEMA_VALIDATION_FEATURE_ID
					+ ")");
		}
		try {
			parser.setFeature(
				SCHEMA_FULL_CHECKING_FEATURE_ID,
				schemaFullChecking);
		} catch (SAXNotRecognizedException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ SCHEMA_FULL_CHECKING_FEATURE_ID
					+ ")");
		} catch (SAXNotSupportedException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ SCHEMA_FULL_CHECKING_FEATURE_ID
					+ ")");
		}
		try {
			parser.setFeature(DYNAMIC_VALIDATION_FEATURE_ID, dynamicValidation);
		} catch (SAXNotRecognizedException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ DYNAMIC_VALIDATION_FEATURE_ID
					+ ")");
		} catch (SAXNotSupportedException e) {
			System.err.println(
				"warning: Parser does not support feature ("
					+ DYNAMIC_VALIDATION_FEATURE_ID
					+ ")");
		}
	}

	public XMLReader getDefaultParser() {
		XMLReader parser = null; // create parser
		try {
			parser = XMLReaderFactory.createXMLReader(DEFAULT_PARSER_NAME);
			setupParserFeatures(parser);
			parser.setContentHandler(this);
			parser.setErrorHandler(this);
		} catch (Exception e) {
			parser = null;
			System.err.println(
				"error: Unable to instantiate parser ("
					+ DEFAULT_PARSER_NAME
					+ ")");
		}
		return parser;
	}

	public void validateFile(String arg) {
		try {
			XMLReader parser = this.getDefaultParser();
			parser.parse(arg);
		} catch (SAXParseException e) {
			// ignore
			System.out.println("Found Parser Errors...");
		} catch (Exception e) {
			System.err.println(
				"error: Parse error occurred - " + e.getMessage());
			Exception se = e;
			if (e instanceof SAXException) {
				se = ((SAXException) e).getException();
			}
			if (se != null)
				se.printStackTrace(System.err);
			else
				e.printStackTrace(System.err);
		}
	}

}
