/*
 * Created on Apr 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package gov.nasa.du.schemavalidator;

/**
 * @author mrabi
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;

import javax.swing.JPanel;
import javax.swing.SwingUtilities;


public class StatusPanel
	extends JPanel
	implements Runnable, ComponentListener {
	private Thread thread;

	private static int gap = 6,
		width = 7,
		offset = -2,
		deltaX = gap + width + offset;
	
	private int borderGap = 3;
	private Rectangle	outerSquare, middleSquare, innerSquare;

	private Rectangle borderSquare = new Rectangle(gap, gap, width, width),
		left,
		top,
		right,
		bottom;

	private int numSquares = 0;

	public void componentHidden(ComponentEvent e) {
	}

	public void componentMoved(ComponentEvent e) {
	}

	public void componentResized(ComponentEvent e) {
		width = getHeight() - (gap * 2);
		deltaX = width + 2;
		
		outerSquare = new Rectangle(gap, gap, width, width);
		middleSquare = new Rectangle(gap, gap + 1, width, width - 2);
		innerSquare = new Rectangle(gap, gap + 2, width, width - 4);

		numSquares = getWidth() / deltaX;

		borderSquare =
			new Rectangle(
				borderGap,
				borderGap,
				getWidth() - (borderGap * 2),
				getHeight() - (borderGap * 2));

		left = new Rectangle(0, 0, borderGap, getHeight());
		top = new Rectangle(0, 0, getWidth(), borderGap);
		right =
			new Rectangle(getWidth() - borderGap, 0, borderGap, getHeight());
		bottom =
			new Rectangle(0, getHeight() - borderGap, getWidth(), borderGap);
	}

	public void componentShown(ComponentEvent e) {
	}

	//RoundRectangle2D

	private AlphaComposite makeComposite(float alpha) {
		int type = AlphaComposite.SRC_OVER;
		return (AlphaComposite.getInstance(type, alpha));
	}

	private void drawSquares(Graphics2D g2d, float alpha, int idx) {
		Composite originalComposite = g2d.getComposite();

		g2d.setComposite(makeComposite(alpha));
		g2d.setPaint(Color.green);
		g2d.fill(outerSquare);

		g2d.setComposite(originalComposite);
	}

	int idx;

	public void paintComponent(Graphics g) {
		super.paintComponent(g);

		if (left == null) {
			return;
		}
		Graphics2D g2d = (Graphics2D) g;

		g2d.setPaint(Color.lightGray);
		g2d.fill(left);
		g2d.fill(top);
		g2d.fill(right);
		g2d.fill(bottom);

		g2d.setPaint(Color.black);

		g2d.drawRoundRect(
			borderGap,
			borderGap,
			getWidth() - (borderGap * 2),
			getHeight() - (borderGap * 2),
			5,
			5);

		g2d.setPaint(Color.lightGray);

		g2d.drawRoundRect(
			borderGap + 1,
			borderGap + 1,
			getWidth() - (borderGap * 2) - 2,
			getHeight() - (borderGap * 2) - 2,
			5,
			5);

		if (animate) {

			int drawRecs = 0;

			if (idx >= numSquares) {
				idx = 0;
			}

			g2d.translate(deltaX * idx++, 0);

			for (int i = 0; i < 3; i++) {
				drawSquares(g2d, ((drawRecs++ * 0.25F) + 0.2F), i);
				g2d.translate(deltaX, 0);
			}
		}

	}

	boolean animate;

	public void start() {
		setBackground(Color.white);
		idx = 0;
		animate = true;

		thread = new Thread(this);
		thread.setPriority(Thread.MIN_PRIORITY);
		thread.setDaemon(true);
		thread.start();
	}

	public void stop() {
		if (animate) {
			animate = false;
			thread.interrupt();
		}
	}

	public void run() {
		Thread me = Thread.currentThread();
		while (thread == me) {
			Runnable updateAComponent = new Runnable() {
				public void run() {
					repaint();
				}
			};
			SwingUtilities.invokeLater(updateAComponent);
			try {
				thread.sleep(50);
			} catch (InterruptedException e) {
				break;
			}
		}
		thread = null;
		Runnable updateAComponent = new Runnable() {
			public void run() {
				repaint(0, 0, 0, getWidth(), getHeight());
			}
		};
		SwingUtilities.invokeLater(updateAComponent);

	}

}
