/*
 * @(#)SchemaValidatorHelp.java	1.6 01/08/08
 *
 * Copyright (c) 2001, by GST, Inc. All Rights Reserved.
 * 
 */
package gov.nasa.du.schemavalidator;
import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.SwingUtilities;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.Document;

/*
 * @version 1.0 08/08/2001
 * @author Muhammad Rabi
 */
public class SchemaValidatorHelp extends JDialog implements ActionListener {
  JPanel panel1 = new JPanel();
  JButton button = new JButton();
  
    public SchemaValidatorHelp(Frame parent) {
	super(parent);
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	HtmlPane html = new HtmlPane();
    setSize(new Dimension(400, 500));

	
  	panel1.setLayout(new BorderLayout());

  	JPanel buttonpanel = new JPanel();
  	buttonpanel.setOpaque(false);
  	button = (JButton) buttonpanel.add( new JButton("Close"));
  	panel1.add(buttonpanel, BorderLayout.SOUTH);

  	button.addActionListener(this);
  	this.setTitle("XML Schema Validator Help");
  	setResizable(true);

  	panel1.add(html,BorderLayout.CENTER);

  	this.setContentPane(panel1);

    }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }
  /**Close the dialog*/
  void cancel() {
    dispose();
  }
  /**Close the dialog on a button event*/
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button) {
      cancel();
    }
  }

} 

class HtmlPane extends JScrollPane implements HyperlinkListener {
    JEditorPane html;
	private static final String helpFileName = "index.html";
    public HtmlPane() {
	try {
		
	    File f = new File (helpFileName);
	    //String s = f.getAbsolutePath();
	    String s = f.getPath();
	    s = "file:"+s;
	    //URL url = new URL(s);
	   // URL url = new URL(cl.getResource(helpFileName));
	    html = new JEditorPane(SchemaValidatorHelp.class.getResource(helpFileName));
	    html.setEditable(false);
	    html.addHyperlinkListener(this);

	    JViewport vp = getViewport();
	    vp.add(html);
	} catch (MalformedURLException e) {
	    System.out.println("Malformed URL: " + e);
	} catch (IOException e) {
	    System.out.println("IOException: " + e);
	}	
    }

    /**
     * Notification of a change relative to a 
     * hyperlink.
     */
    public void hyperlinkUpdate(HyperlinkEvent e) {
	if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
	    linkActivated(e.getURL());
	}
    }

    /**
     * Follows the reference in an
     * link.  The given url is the requested reference.
     * By default this calls <a href="#setPage">setPage</a>,
     * and if an exception is thrown the original previous
     * document is restored and a beep sounded.  If an 
     * attempt was made to follow a link, but it represented
     * a malformed url, this method will be called with a
     * null argument.
     *
     * @param u the URL to follow
     */
    protected void linkActivated(URL u) {
	Cursor c = html.getCursor();
	Cursor waitCursor = Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);
	html.setCursor(waitCursor);
	SwingUtilities.invokeLater(new PageLoader(u, c));
    }

    /**
     * temporary class that loads synchronously (although
     * later than the request so that a cursor change
     * can be done).
     */
    class PageLoader implements Runnable {
	
	PageLoader(URL u, Cursor c) {
	    url = u;
	    cursor = c;
	}

        public void run() {
	    if (url == null) {
		// restore the original cursor
		html.setCursor(cursor);

		// PENDING(prinz) remove this hack when 
		// automatic validation is activated.
		Container parent = html.getParent();
		parent.repaint();
	    } else {
		Document doc = html.getDocument();
		try {
		    html.setPage(url);
		} catch (IOException ioe) {
		    html.setDocument(doc);
		    getToolkit().beep();
		} finally {
		    // schedule the cursor to revert after
		    // the paint has happended.
		    url = null;
		    SwingUtilities.invokeLater(this);
		}
	    }
	}

	URL url;
	Cursor cursor;
    }

}
